' Region Description
'
' Name: jose-versioncheck.vbs
' Author: Nils Kaczenski, faq-o-matic.net
' Version: 1.0
' Description: Checks whether a newer version of Jos exists on the Web
'
'
' EndRegion

' see http://msdn.microsoft.com/de-de/library/ms535874(en-us,VS.85).aspx
' and http://msdn.microsoft.com/de-de/library/ms757846(v=VS.85).aspx
Option Explicit
Dim objXML
Dim NodeBetaVersionPrintable, NodeBetaVersionNumber, NodeBetaVersionBeta, NodeBetaDownloadUrl
Dim strNodeBetaVersionPrintable, intNodeBetaVersionNumber, intNodeBetaVersionBeta, strBetaDownloadUrl
Dim NodeVersionPrintable, NodeVersionNumber, NodeDownloadUrl
Dim strNodeVersionPrintable, intNodeVersionNumber, strDownloadUrl
Dim intJoseVersionLocal, intJoseVersionBetaLocal, strJoseVersionLocalPrintable 
Dim blnUpdate, strText

intJoseVersionLocal = 31
intJoseVersionBetaLocal = 0
strJoseVersionLocalPrintable = "3.1"
blnUpdate = False

Set objXML = CreateObject("MSXML2.XMLHTTP.3.0")
On Error Resume Next
' query the URL with a synchronous call
objXML.Open "GET", "http://www.faq-o-matic.net/wp-content/uploads/joseversion.xml", False
objXML.Send
If Err.number <> 0 Then
	WScript.Echo "Jos-Versions test" & vbNewLine & "Error when accessing the version data on the Web:" _
		& vbNewLine & vbTab & Err.Description & " (" & Err.number & ")"
	WScript.Quit
End If
On Error Goto 0

If objXML.status = 200 Then
	' get latest Beta version
	Set NodeBetaVersionPrintable = objXML.responseXML.selectSingleNode("//joseversion/josebeta/versionprintable")
	strNodeBetaVersionPrintable = NodeBetaVersionPrintable.text
	Set NodeBetaVersionNumber = objXML.responseXML.selectSingleNode("//joseversion/josebeta/versionnumber")
	intNodeBetaVersionNumber = CInt(NodeBetaVersionNumber.text)
	Set NodeBetaVersionBeta = objXML.responseXML.selectSingleNode("//joseversion/josebeta/versionbeta")
	intNodeBetaVersionBeta = CInt(NodeBetaVersionBeta.text)
	Set NodeBetaDownloadUrl = objXML.responseXML.selectSingleNode("//joseversion/josebeta/downloadurl")
	strBetaDownloadUrl = NodeBetaDownloadUrl.text

	' get latest stable version
	Set NodeVersionPrintable = objXML.responseXML.selectSingleNode("//joseversion/josestable/versionprintable")
	strNodeVersionPrintable = NodeVersionPrintable.text
	Set NodeVersionNumber = objXML.responseXML.selectSingleNode("//joseversion/josestable/versionnumber")
	intNodeVersionNumber = CInt(NodeVersionNumber.text)
	Set NodeDownloadUrl = objXML.responseXML.selectSingleNode("//joseversion/josestable/downloadurl")
	strDownloadUrl = NodeDownloadUrl.text

	strText = "Local Version: " & strJoseVersionLocalPrintable & vbNewLine & vbNewLine _
		& "Latest stable version: " & strNodeVersionPrintable
	If intJoseVersionLocal < intNodeVersionNumber Then
		strText = strText & vbNewLine _
			& "The is newer than the local version on the Web." & vbNewLine _
			& "Download under: " & strDownloadUrl
		blnUpdate = True
	End If

	If intJoseVersionLocal = intNodeVersionNumber And intJoseVersionBetaLocal > 0 And intNodeBetaVersionNumber = 0 Then
		strText = strText & vbNewLine _
			& "The beta is finished. The final version can be found under: " & vbNewLine _
			& strDownloadUrl
	End If

	strText = strText & vbNewLine & vbNewLine & "Letzte Betaversion: " & strNodeBetaVersionPrintable
	If intJoseVersionLocal <= intNodeBetaVersionNumber And intJoseVersionBetaLocal < intNodeBetaVersionBeta Then
		strText = strText & vbNewLine _
		& "The beta version on the Web is newer than the local version." & vbNewLine _
		& "Download unter: " & strBetaDownloadUrl
		blnUpdate = True
	End If

	If Not blnUpdate Then strText = strText & vbNewLine & vbNewLine & "No update available."

Else
	strText = objXML.status & ": " & objXML.statusText
	strText = "Error when accessing the version data: " & vbNewLine & strText
End If

WScript.Echo "Jos-Version test" & vbNewLine & vbNewLine  _
	& strText & vbNewLine


